unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart, TeeDashBoard, DB,
  ADODB, TeeSubChart, DBChart, Buttons, Series, TeeComma, TeeEdit, TeeDonut, TeCanvas,
  TeeKnobGauge, StdCtrls;

type
  TForm3 = class(TForm)
    DashBoard1: TDashBoard;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    Panel1: TPanel;
    TeeGDIPlus1: TTeeGDIPlus;
    Button1: TButton;
    ChartPreviewer1: TChartPreviewer;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    Filled: TBarSeries;
    UnFilled: TBarSeries;
    Cancelled: TBarSeries;
    Lost: TBarSeries;
    SamplePie: TPieSeries;
    Donut: TDonutSeries;
    procedure GetMarkText(Sender: TChartSeries; ValueIndex: Integer;
      var MarkText: string);
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

procedure TForm3.GetMarkText(Sender: TChartSeries; ValueIndex: Integer;
  var MarkText: string);
begin

  MarkText := FloatToStr(TChartSeries(Sender).YValues[ValueIndex]);

end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  Dashboard1.ShowEditor;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  ChartPreviewer1.Execute;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ADOQuery1.Active := false;
end;

procedure TForm3.FormShow(Sender: TObject);
begin

 ADOQuery1.Active := true;

 DashBoard1.Title.Caption := 'My Dashboard';
 DashBoard1.Title.Font.Size := 20;
 DashBoard1.Title.Font.Color := clWhite;
// DashBoard1.MarginTop := 0;

 Filled := TBarSeries.Create(Self);
 Filled.ParentChart    := DashBoard1.AddChart('Bookings');
// TSubChart(DashBoard1.Charts.Items[0]).Chart.Height := 10;
 DashBoard1.Charts.Items[0].Chart.MarginTop := 10;
 DashBoard1.Charts.Items[0].Chart.MarginBottom := 10;
 DashBoard1.Charts.Items[0].Chart.Title.Visible := true;
 DashBoard1.Charts.Items[0].Chart.Title.Text.Clear;
 DashBoard1.Charts.Items[0].Chart.Title.Text.Add('Filled/Unfilled Bookings 2015');
 DashBoard1.Charts.Items[0].Chart.Title.Font.Color := clWhite;
 DashBoard1.Charts.Items[0].Chart.Title.Font.Size := 12;

 DashBoard1.Charts.Items[0].Chart.Legend.Visible := true;
 DashBoard1.Charts.Items[0].Chart.Legend.Title.Caption := 'Bookings';

 Filled.StackGroup := 0;
 Filled.MultiBar:= mbStacked;
 Filled.Legend.Text := 'Filled';
 Filled.OnGetMarkText := GetMarkText;
 Filled.MarksonBar := True;
 Filled.MarksLocation := mlCenter;

 UnFilled := TBarSeries.Create(Self);
 UnFilled.ParentChart    := DashBoard1.Charts.Items[0].Chart;
 Unfilled.StackGroup := 0;
 UnFilled.MultiBar:= mbStacked;
 UnFilled.Legend.Text := 'UnFilled';
 UnFilled.OnGetMarkText := GetMarkText;
 UnFilled.MarksonBar := True;
 UnFilled.MarksLocation := mlCenter;

 // Filled.DataSource := ADOQuery1;
 with ADOQuery1 do
 begin
   while NOT EOF do
   begin

//     Filled.AddBar(fieldbyname('Filled').asinteger, InttoStr(fieldbyname('Filled').asinteger), clRed);
     Filled.Add(fieldbyname('Filled').asinteger,  fieldbyname('MonthName').asstring);
     Filled.Marks.Text := InttoStr(fieldbyname('Filled').asinteger);
     UnFilled.Add(fieldbyname('UnFilled').asinteger,  fieldbyname('MonthName').asstring);
     UnFilled.Marks.Text := InttoStr(fieldbyname('UnFilled').asinteger);

     next;
   end;
 end;

// Filled.AddBar(20, 'Label', clRed);
// Filled.AddBar(21, 'Label', clRed);
// Filled.AddBar(22, 'Label', clRed);
// Filled.AddBar(25, 'Label', clRed);
// Filled.AddBar(30, 'Label', clRed);

 SamplePie :=  TPieSeries.Create(self);
 SamplePie.ParentChart := DashBoard1.AddChart('Diary');
// SamplePie.AddPie(10, 'Segment 1', clRed);
// SamplePie.AddPie(20, 'Segment 2', clBlue);
// SamplePie.AddPie(30, 'Segment 3', clYellow);
// SamplePie.AddPie(40, 'Segment 4', clGreen);
 SamplePie.Add(10, 'Manchester');
 SamplePie.Add(20, 'Oxford');
 SamplePie.Add(30, 'Newcastle');
 SamplePie.Add(40, 'London');

 SamplePie.ExplodeBiggest:=10;
 SamplePie.BevelPercent:=15;
 SamplePie.EdgeStyle := edFlat;


 Donut := TDonutSeries.Create(self);
 with Donut do
 begin
   ParentChart := DashBoard1.AddChart('Donut');
   Add(10, 'Nigel Moreton');
   Add(20, 'Phil Brown');
   Add(30, 'Jane King');
   Add(40, 'Alice Jess');

   ExplodeBiggest:=10;
   BevelPercent:=15;
   EdgeStyle := edFlat;
 end;

(*
 Cancelled := TBarSeries.Create(Self);
 Cancelled.ParentChart    := DashBoard1.Charts[0].Chart;
 Cancelled.StackGroup := 1;
 Cancelled.Legend.Text := 'Cancelled';
 Cancelled.MultiBar:= mbStacked;
 Cancelled.YValues.ValueSource  := 'CancelledShift';
 Cancelled.DataSource := ADOQuery1;

 Lost := TBarSeries.Create(Self);
 Lost.ParentChart    := Form3.DBChart1;
 Lost.StackGroup := 2;
 Lost.Legend.Text := 'Lost';
 Lost.MultiBar:= mbStacked;
 Lost.YValues.ValueSource  := 'LostShift';
 Lost.DataSource := ADOQuery1;
*)
// DBChart1.Title.Text.Clear;
// DBChart1.Title.Text.Add('Filled/Unfilled Bookings 2015');



end;

end.
